#!/bin/bash
#
# trans_recordings.sh   starts trans_recordings process
#
#
ulimit -c unlimited
ulimit -n 65535
TRANS_RECORDINGS_DIR=/usr/local/rserver
SLEEPSECS=4
LOGFILE=/var/log/trans_recordings_sh.log

message() {
    echo "$1" >&2
    if test "x$LOGFILE" != "x" ; then
        echo "rserver[$$]: $1" >> "$LOGFILE"
    fi
}

run_trans_recordings()
{
        while :; do

                cd ${TRANS_RECORDINGS_DIR}

		/usr/bin/perl /usr/local/rserver/trans_recordings.pl > $LOGFILE 2>&1	

                EXITSTATUS=$?

                message "Trans_recordings process ended with exit status $EXITSTATUS"

                if test "x$EXITSTATUS" = "x0" ; then
                    # Properly shutdown....
                    message "Trans_recordings process shutdown normally."
                    exit 0
                fi

                message "Automatically restarting Trans_recordings process."
                sleep $SLEEPSECS

        done
}

run_trans_recordings &

