#!/usr/bin/perl

use strict;

my $option = shift;

open(LOG, '>>', "/tmp/rserver_database_funcs.log");

if($option eq "create") {
	create_database(*LOG);
	update_rc_local(*LOG);
	update_fonmon_cfg(*LOG);
} else {
	if ($option eq "insert") {
		die "Usage: $0 insert <server_id> <password>" unless (@ARGV == 2);
		my $server_id = shift;
		my $password = shift;
	
		my $cmd = "/usr/bin/sqlite3 /usr/local/rserver/rserver.db 'INSERT INTO user VALUES(NULL,$server_id,$password)'";
		print LOG $cmd."\n";
		system($cmd);
	
		# If INSERT failed, the entry might have existed, use UPDATE instead. If INSERT didn't fail, this line doesn't do any harm.	
		my $cmd = "/usr/bin/sqlite3 /usr/local/rserver/rserver.db \"UPDATE user SET password='$password' WHERE username='$server_id'\"";
		print LOG $cmd."\n";
		system($cmd);
	}  else {
		print "Usage: $0 <create|insert> <server_id> <password>\n";
	}
}

close(LOG);

exit;

sub create_database
{
	my $log = shift;
	if(-e "/usr/local/rserver/rserver.db") {
		print $log "Database has already been created\n";
		return;
	}

	system("/usr/bin/sqlite3 /usr/local/rserver/rserver.db < /usr/local/rserver/rserver.sqlite");
	system("/etc/init.d/rserver_service restart");
}

sub update_rc_local
{
	my $log = shift;
	my $ret = open RC_LOCAL, "<", "/etc/rc.local";
	if(!$ret) {
        	print $log "Failed to open /etc/rc.local file for reading.\n";
		return;
	}
	
	my @content = <RC_LOCAL>;
	if(grep {$_ =~ /RecordAll|red5|rserver/i} @content)
	{
        	print $log "Startup entries for RecordAll has already been added.\n";
	        close RC_LOCAL;
	        return;
	}

	close RC_LOCAL;
	
        $ret = open RC_LOCAL, ">>", "/etc/rc.local";
        if(!$ret) {
                print $log "Failed to open /etc/rc.local file for writing.\n";
                return;
        }
	
	my $line1 = "# Load servics for RecordAll";
	my $line2 = "/etc/init.d/red5 start";
	my $line3 = "/etc/init.d/rserver_service start";
	my $line4 = "/etc/init.d/trans_recordings start";

	print RC_LOCAL "\n";
	print RC_LOCAL $line1."\n";
	print RC_LOCAL $line2."\n";
	print RC_LOCAL $line3."\n";
	print RC_LOCAL $line4."\n";
	close RC_LOCAL;

	print $log "Startup entries for RecordAll has been added to /etc/rc.local successfully.\n";
	return;
}

sub update_fonmon_cfg
{
        my $log = shift;
        my $ret = open FONMON_CFG, "<", "/etc/asterisk/FONmon.conf";
        if(!$ret) {
                print $log "Failed to open /etc/asterisk/FONmon.conf file for reading.\n";
                return;
        }

        my @content = <FONMON_CFG>;
        if(grep {$_ =~ /RecordAll/i} @content)
        {
                print $log "FONmon entries for RecordAll has already been added.\n";
                close FONMON_CFG;
                return;
        }

        close FONMON_CFG;

        $ret = open FONMON_CFG, ">>", "/etc/asterisk/FONmon.conf";
        if(!$ret) {
                print $log "Failed to open /etc/asterisk/FONmon.conf file for writing.\n";
                return;
        }

        my $line1 = "# Make sure RecordAll service is running";
        my $line2 = "checkrecordall = 1";
        my $line3 = "recordall_interval = 10";

        print FONMON_CFG "\n";
        print FONMON_CFG $line1."\n";
        print FONMON_CFG $line2."\n";
        print FONMON_CFG $line3."\n";
        close FONMON_CFG;

        print $log "FONmon entries for RecordAll has been added to /etc/asterisk/FONmon.conf successfully.\n";
        
	system("/etc/init.d/FONmon restart");

        print $log "FONmon restarted.\n";

        return;	
}
